/* simplest of all: 
DEFINE VARIABLE a AS HANDLE NO-UNDO.
DISPLAY 
   a:name 
   a:name:type 
   a::b 
   a::b::c 
   a::name::display.
*/

DEFINE VARIABLE dh AS HANDLE NO-UNDO.
DEFINE VARIABLE bh AS HANDLE NO-UNDO.
DEFINE VARIABLE qh AS HANDLE NO-UNDO.
DEFINE VARIABLE th AS HANDLE NO-UNDO.

CREATE TEMP-TABLE th.
th:ADD-FIELDS-FROM("Customer").
th:TEMP-TABLE-PREPARE("gigel").

bh = th:DEFAULT-BUFFER-HANDLE.
FOR EACH Customer NO-LOCK:
    bh:BUFFER-CREATE.
    bh:BUFFER-COPY(BUFFER Customer:HANDLE).
END.

/* CREATE DATASET dh.   -- not implemented yet in P2J */
/* dh:ADD-BUFFER(bh).   -- not implemented yet in P2J */
/* dh:ADD-BUFFER(bh:NAME). -- not working this way */

CREATE QUERY qh.
qh:SET-BUFFERS(bh).
qh:QUERY-PREPARE("FOR EACH " + bh:NAME + " WHERE id GT 2").
qh:QUERY-OPEN().
qh:GET-NEXT().

IF NOT qh:QUERY-OFF-END THEN
    DISPLAY 
        SKIP STRING(bh:ROWID)   LABEL "bh:ROWID"
        SKIP bh:NAME            LABEL "bh:NAME"
        SKIP dh::gigel          LABEL "dh::gigel"
        SKIP dh::gigel::NAME    LABEL "dh::gigel::NAME"
        SKIP STRING(dh::gigel)         LABEL "STRING(dh::gigel)"
        SKIP dh::gigel::NAME + "8888"  LABEL "dh::gigel::NAME + '8888'"
        SKIP bh::NAME                  LABEL "bh::NAME"
        SKIP bh:BUFFER-FIELD("Name")                        LABEL "bh:BUFFER-FIELD('Name')"                          /* this is handle representation */
        SKIP STRING(bh:BUFFER-FIELD("Name"):BUFFER-VALUE()) LABEL "bh:BUFFER-FIELD('Name'):BUFFER-VALUE()"
/*        SKIP dh:GET-BUFFER-HANDLE("gigel")::Nume            LABEL "dh:GET-BUFFER-HANDLE('gigel')::Name"            -- mixed chaining not supported now */
/*        SKIP dh::gigel:BUFFER-FIELD("Name"):BUFFER-VALUE()  LABEL "dh::gigel:BUFFER-FIELD('Name'):BUFFER-VALUE()"  -- mixed chaining not supported now */
        SKIP STRING(dh:GET-BUFFER-HANDLE("gigel"):BUFFER-FIELD("Name"):BUFFER-VALUE())
                                LABEL "dh:GET-BUFFER-H('gigel'):BUFFER-F('Name'):BUFFER-VALUE()"
    SKIP
    WITH SIDE-LABELS.
ELSE 
    DISPLAY bh:NAME "not found" SKIP.


